<?php

/**
 * @file
 * Shim for Drupal core's file copy unit test.
 */

namespace Drupal\Tests\migrate_devel_file_copy\Unit\Plugin\migrate\process;

use Drupal\Tests\migrate\Unit\process\FileCopyTest;

$drupal_major_minor = implode('.',
  [
    explode('.', \Drupal::VERSION)[0],
    explode('.', \Drupal::VERSION)[1],
  ]
);
if (version_compare($drupal_major_minor, '9.2', 'le')) {
  /**
   * Shim for Drupal core 9.2-.
   */
  abstract class FileCopyTestBaseShim extends FileCopyTest {

    /**
     * {@inheritdoc}
     */
    protected function assertPlugin($configuration, $expected) {
      $this->doAssertPlugin($configuration, $expected);
    }

  }
}
else {
  /**
   * Shim for Drupal core 9.3+.
   */
  abstract class FileCopyTestBaseShim extends FileCopyTest {

    /**
     * {@inheritdoc}
     */
    protected function assertPlugin(array $configuration, int $expected): void {
      $this->doAssertPlugin($configuration, $expected);
    }

  }
}
